package pwc.taxtech.atms.controller;

import com.google.errorprone.annotations.FormatString;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.MediaType;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;
import pwc.taxtech.atms.dto.vatdto.ImportVoucherDto;
import pwc.taxtech.atms.dto.vatdto.QueryJeDto;
import pwc.taxtech.atms.service.IdentityService;
import pwc.taxtech.atms.vat.service.impl.JournalEntryImportServiceImpl;

@RestController
@RequestMapping(value = "/api/v1/journalEntryImport")
public class JournalEntryImportController {

    @Autowired
    private JournalEntryImportServiceImpl journalEntryDataImportService;
    @Autowired
    private IdentityService identityService;

    @ApiOperation(value = "queryJournalEntryData", notes = "")
    @RequestMapping(value = "/queryJournalEntryData", method = RequestMethod.POST)
    public ResponseEntity queryJournalEntryData(@RequestBody QueryJeDto queryJeDto) {
        return ResponseEntity.ok(journalEntryDataImportService.qeryJournalEntryData(queryJeDto));
    }

    @ApiOperation(value = "getValidationInfo", notes = "")
    @RequestMapping(value = "getValidationInfo/{type}/{period}", method = RequestMethod.GET)
    public ResponseEntity getValidationInfo(@PathVariable Integer type, @PathVariable Integer period) {
        return ResponseEntity.ok(journalEntryDataImportService.getValidationInfoList(type, period));
    }

    @RequestMapping(value = "/importJournalEntry", method = RequestMethod.POST, produces = MediaType.APPLICATION_JSON_UTF8_VALUE)
    public ResponseEntity ImportJournalEntryData(@RequestBody ImportVoucherDto importParam) {
        journalEntryDataImportService.ImportJournalEntryData(importParam.VoucherList, importParam.ImportType,
                identityService.getIdentityUser().getID());
        return ResponseEntity.ok().build();
    }

    @RequestMapping(value = "importAuditAdjust/{period:int}", method = RequestMethod.POST, produces = MediaType.APPLICATION_JSON_UTF8_VALUE)
    public ResponseEntity ImportAuditAdjust(@RequestBody ImportVoucherDto importParam, int period) {
        return ResponseEntity.ok().body(journalEntryDataImportService.ImportAuditAdjust(importParam.VoucherList,
                period, importParam.ImportType, identityService.getIdentityUser().getID()));
    }

    @RequestMapping(value = "getAuditAdjust/{period}", method = RequestMethod.POST, produces = MediaType.APPLICATION_JSON_UTF8_VALUE)
    public ResponseEntity GetAuditAdjust(int period) {
        return ResponseEntity.ok().body(journalEntryDataImportService.GetAuditAdjust(period));
    }


    @RequestMapping(value = "queryAuditAdjust", method = RequestMethod.POST, produces = MediaType.APPLICATION_JSON_UTF8_VALUE)
    public ResponseEntity QueryAuditAdjust(QueryJeDto queryDto) {
        return ResponseEntity.ok().body(journalEntryDataImportService.QueryAuditAdjust(queryDto));
    }

}

